// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMRPars.pas' rev: 3.00

#ifndef SMRParsHPP
#define SMRParsHPP
#include <TypInfo.hpp>
#include <Dialogs.hpp>
#include <SMRTypes.hpp>
#include <Db.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smrpars
{
//-- type declarations -------------------------------------------------------
enum SMCANOp { canNOTDEFINED, canISBLANK, canNOTBLANK, canEQ, canNE, canGT, canLT, canGE, canLE, canNOT, 
	canAND, canOR, canFIELD2, canCONST2, canMINUS, canADD, canSUB, canMUL, canDIV, canMOD, canSUM, canCOUNT, 
	canMIN, canMAX, canAVG, canLIKE, canIN, canFUNC2, canLISTELEM2, canASSIGN };

typedef SMCANOp *PSMCANOp;

enum SMNODEClass { nodeNULL, nodeUNARY, nodeBINARY, nodeCOMPARE, nodeFIELD, nodeCONST, nodeLIST, nodeFUNC, 
	nodeLISTELEM };

struct SMCANExpr;
typedef SMCANExpr *PSMCANExpr;

typedef PSMCANExpr *PPSMCANExpr;

#pragma pack(push, 1)
struct SMCANExpr
{
	Word iVer;
	Word iTotalSize;
	Word iNodes;
	Word iNodeStart;
	Word iLiteralStart;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct SMCANHdr
{
	SMNODEClass nodeClass;
	SMCANOp canOp;
} ;
#pragma pack(pop)

typedef SMCANHdr *PSMCANHdr;

enum TExprNodeKind { enField, enConst, enOperator, enFunc };

enum TExprScopeKind { skField, skAgg, skConst };

struct TExprNode;
typedef TExprNode *PExprNode;

struct TExprNode
{
	TExprNode *FNext;
	TExprNodeKind FKind;
	bool FPartial;
	SMCANOp FOperator;
	System::Variant FData;
	TExprNode *FLeft;
	TExprNode *FRight;
	int FDataType;
	int FDataSize;
	Classes::TList* FArgs;
	TExprScopeKind FScopeKind;
} ;

typedef void __fastcall (__closure *TGetVariableEvent)(System::TObject* Sender, System::AnsiString VariableName
	, bool &Accept, Db::TFieldType &VariableType, System::Variant &Value);

class DELPHICLASS TFilterExpr;
class PASCALIMPLEMENTATION TFilterExpr : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TGetVariableEvent FVariableEvent;
	Classes::TList* FDataSets;
	Db::TFilterOptions FOptions;
	TExprNode *FNodes;
	SMCANExpr *FExprBuffer;
	int FExprBufSize;
	int FExprNodeSize;
	int FExprDataSize;
	Db::TField* __fastcall FieldFromNode(PExprNode Node);
	char * __fastcall GetExprData(int Pos, int Size);
	int __fastcall PutConstBCD(const System::Variant &Value, int Decimals);
	int __fastcall PutConstBool(const System::Variant &Value);
	int __fastcall PutConstDate(const System::Variant &Value);
	int __fastcall PutConstDateTime(const System::Variant &Value);
	int __fastcall PutConstFloat(const System::Variant &Value);
	int __fastcall PutConstInt(int DataType, const System::Variant &Value);
	int __fastcall PutConstNode(int DataType, char * Data, int Size);
	int __fastcall PutConstStr(const System::AnsiString Value);
	int __fastcall PutConstTime(const System::Variant &Value);
	int __fastcall PutData(char * Data, int Size);
	int __fastcall PutExprNode(PExprNode Node, SMCANOp ParentOp);
	int __fastcall PutFieldNode(Db::TField* Field, PExprNode Node);
	int __fastcall PutNode(SMNODEClass NodeType, SMCANOp OpType, int OpCount);
	void __fastcall SetNodeOp(int Node, int Index, int Data);
	int __fastcall PutConstant(PExprNode Node);
	
public:
	__fastcall TFilterExpr(Classes::TList* DataSets, Db::TFilterOptions Options, TGetVariableEvent AGetVariableEvent
		);
	__fastcall virtual ~TFilterExpr(void);
	PExprNode __fastcall NewCompareNode(Db::TField* Field, SMCANOp Operator, const System::Variant &Value
		);
	PExprNode __fastcall NewNode(TExprNodeKind Kind, SMCANOp Operator, const System::Variant &Data, PExprNode 
		Left, PExprNode Right);
	PSMCANExpr __fastcall GetFilterData(PExprNode Root);
	__property Classes::TList* DataSets = {write=FDataSets};
};

enum TExprToken { etEnd, etSymbol, etName, etLiteral, etLParen, etRParen, etEQ, etNE, etGE, etLE, etGT, 
	etLT, etADD, etSUB, etMUL, etDIV, etComma, etLIKE, etISNULL, etISNOTNULL, etIN };

class DELPHICLASS TExprParser;
class PASCALIMPLEMENTATION TExprParser : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TFilterExpr* FFilter;
	System::AnsiString FText;
	char *FSourcePtr;
	char *FTokenPtr;
	System::AnsiString FTokenString;
	System::AnsiString FStrTrue;
	System::AnsiString FStrFalse;
	TExprToken FToken;
	TExprToken FPrevToken;
	SMCANExpr *FFilterData;
	bool FNumericLit;
	int FDataSize;
	Classes::TList* FDataSets;
	void __fastcall NextToken(void);
	bool __fastcall NextTokenIsLParen(void);
	PExprNode __fastcall ParseExpr(void);
	PExprNode __fastcall ParseExpr2(void);
	PExprNode __fastcall ParseExpr3(void);
	PExprNode __fastcall ParseExpr4(void);
	PExprNode __fastcall ParseExpr5(void);
	PExprNode __fastcall ParseExpr6(void);
	PExprNode __fastcall ParseExpr7(void);
	System::AnsiString __fastcall TokenName(void);
	bool __fastcall TokenSymbolIs(const System::AnsiString S);
	bool __fastcall TokenSymbolIsFunc(const System::AnsiString S);
	void __fastcall GetFuncResultInfo(PExprNode Node);
	void __fastcall TypeCheckArithOp(PExprNode Node);
	void __fastcall GetScopeKind(PExprNode Root, PExprNode Left, PExprNode Right);
	System::Variant __fastcall EvalNode(PExprNode Node);
	
public:
	__fastcall TExprParser(Classes::TList* DataSets, const System::AnsiString Text, Db::TFilterOptions 
		Options, TGetVariableEvent AGetVariableEvent);
	__fastcall virtual ~TExprParser(void);
	void __fastcall SetExprParams(const System::AnsiString Text);
	System::Variant __fastcall Evaluate(void);
};

struct FMTBcd;
typedef FMTBcd *PFMTBcd;

#pragma pack(push, 1)
struct FMTBcd
{
	Byte iPrecision;
	Byte iSignSpecialPlaces;
	Byte iFraction[32];
} ;
#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
#define fldUNKNOWN (Byte)(0)
#define fldZSTRING (Byte)(1)
#define fldDATE (Byte)(2)
#define fldBLOB (Byte)(3)
#define fldBOOL (Byte)(4)
#define fldINT16 (Byte)(5)
#define fldINT32 (Byte)(6)
#define fldFLOAT (Byte)(7)
#define fldBCD (Byte)(8)
#define fldBYTES (Byte)(9)
#define fldTIME (Byte)(10)
#define fldTIMESTAMP (Byte)(11)
#define fldUINT16 (Byte)(12)
#define fldUINT32 (Byte)(13)
#define fldFLOATIEEE (Byte)(14)
#define fldVARBYTES (Byte)(15)
#define fldLOCKINFO (Byte)(16)
#define fldCURSOR (Byte)(17)
#define fldINT64 (Byte)(18)
#define fldUINT64 (Byte)(19)
#define fldADT (Byte)(20)
#define fldARRAY (Byte)(21)
#define fldREF (Byte)(22)
#define fldTABLE (Byte)(23)
#define fldDATETIME (Byte)(24)
#define fldFMTBCD (Byte)(25)
#define CANEXPRVERSION (Byte)(2)
extern PACKAGE Byte FldTypeMap[23];
extern PACKAGE System::Variant __fastcall EvaluateValue(Classes::TList* lstDS, System::AnsiString Expression
	, TGetVariableEvent AGetVariableEvent);
extern PACKAGE System::Variant __fastcall GetCalculatedValue(Classes::TList* lstDS, const System::AnsiString 
	Expression, const System::AnsiString Format, Smrtypes::TCalcType CalcType, const System::Variant &PrevValue
	, const System::Variant &CurValue, TGetVariableEvent AGetVariableEvent);

}	/* namespace Smrpars */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smrpars;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMRPars
